library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity decode is
	Port (
			input  :  in  std_logic_vector(11 downto 0);
		   output :  out std_logic_vector(7 downto 0)
		  );
end decode;

architecture Behavioral of decode is

begin 

	with input(5 downto 0) select
	output(3 downto 0) <=	"0000" when "110100",
									"0001" when "101100",
									"0010" when "011100",
									"0011" when "110010",
									"0100" when "011010",
									"0101" when "100110",
									"0110" when "010110",
									"0111" when "001110",
									"1000" when "110001",
									"1001" when "101001",
									"1010" when "011001", 
									"1011" when "100101",
									"1100" when "001101",
									"1101" when "100011",
									"1110" when "010011", 
									"1111" when others;
					
	with input(11 downto 6) select
	output(7 downto 4) <=	"0000" when "110100",
									"0001" when "101100",
									"0010" when "011100",
									"0011" when "110010",
									"0100" when "011010",
									"0101" when "100110",
									"0110" when "010110",
									"0111" when "001110",
									"1000" when "110001",
									"1001" when "101001", 
									"1010" when "011001", 
									"1011" when "100101",
									"1100" when "001101",
									"1101" when "100011",
									"1110" when "010011", 
									"1111" when others;
					
end Behavioral;